/***************************************************************************
                          connectdlg.cpp  -  description
                             -------------------
    begin                : P ?ec 12 2002
    copyright            : (C) 2002 by Lumir Vanek
    email                : lvanek@users.sourceforge.net 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "connectdlg.h"

#include <qlineedit.h>
#include <qspinbox.h>

#include <kmessagebox.h>
#include <klocale.h>

ConnectDlg::ConnectDlg(QWidget *parent, const char *name )
	: ConnectDlgBase(parent,name)
{
}

ConnectDlg::~ConnectDlg()
{
}

/** Called, when user press OK button */
void ConnectDlg::slotOK()
{
	if(m_pLineEditConnectionName->text().length() == 0)
		{ KMessageBox::sorry(this, i18n("Fill name !"));
			return;
		}

	if(m_pLineEditHostNameOrIP->text().length() == 0)
		{ KMessageBox::sorry(this, i18n("Fill host name or IP !"));
			return;
		}

	if(m_pLineEditCommunity->text().length() == 0)
		{ KMessageBox::sorry(this, i18n("Fill community string !"));
			return;
		}
			
	m_strHostNameOrIP = m_pLineEditHostNameOrIP->text();
  m_strConnectionName = m_pLineEditConnectionName->text();
	m_strCommunity = m_pLineEditCommunity->text();
	m_iPort = m_pSpinBoxPort->value();

	if(m_strConnectionName.find('.') >= 0)
		{ KMessageBox::sorry(this, i18n("Name cannot contain dots !"));
			return;
		}
    	
  accept();
}
