/***************************************************************************
                          connectdlg.h  -  description
                             -------------------
    begin                : P ?ec 12 2002
    copyright            : (C) 2002 by Lumir Vanek
    email                : lvanek@users.sourceforge.net 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONNECTDLG_H
#define CONNECTDLG_H

#include <qwidget.h>
#include <connectdlgbase.h>

/**Dialog for connect to SNMP device
  *@author Lumir Vanek
  */

class ConnectDlg : public ConnectDlgBase
{
   Q_OBJECT
public: 
	ConnectDlg(QWidget *parent=0, const char *name=0);
	~ConnectDlg();
public: // Public attributes

  /** Host name or IP adress for SNMP device */
  QString m_strHostNameOrIP;
  /** Name of connection */
  QString m_strConnectionName;
  /** Community string */
  QString m_strCommunity;
  /** Port number */
  int m_iPort;
  
protected slots: // Protected slots
  /** Called, when user press OK button */
  void slotOK();
};

#endif
