/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Po ec  8 10:15:40 CEST 2002
    copyright            : (C) 2002 by Lumir Vanek
    email                : lvanek@users.sourceforge.net 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "snmpbrowser.h"

static const char *description =
	I18N_NOOP("SNMP Browser");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

	KAboutData aboutData("snmpbrowser",
                       I18N_NOOP("SNMP Browser"),
		                   VERSION,
                       description,
                       KAboutData::License_GPL,
		                   "(c) 2002, Lumir Vanek",
                       0,
                       "http://snmpbrowser.sourceforge.net",
                       "lvanek@users.sourceforge.net"
                      );

	aboutData.addAuthor("Lumir Vanek",0, "lvanek@users.sourceforge.net ");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication app;
 
  if (app.isRestored())
  {
    RESTORE(SNMPBrowserApp);
  }
  else 
  {
    SNMPBrowserApp *snmpbrowser = new SNMPBrowserApp();
    snmpbrowser->show();

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		
		if (args->count())
		{
        snmpbrowser->openDocumentFile(args->arg(0));
		}
		else
		{
		  snmpbrowser->openDocumentFile();
		}
		args->clear();
  }

  return app.exec();
}  
